"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const disposable_1 = require("@reactive-js/disposable");
class AbstractEnumerator {
    constructor() {
        this.add = disposable_1.disposableMixin.add;
        this.disposable = disposable_1.createDisposable();
        this.dispose = disposable_1.disposableMixin.dispose;
    }
    get isDisposed() {
        return this.disposable.isDisposed;
    }
}
exports.AbstractEnumerator = AbstractEnumerator;
class AbstractDelegatingEnumerator extends AbstractEnumerator {
    constructor(delegate) {
        super();
        this.delegate = delegate;
        delegate.add(this);
    }
}
exports.AbstractDelegatingEnumerator = AbstractDelegatingEnumerator;
//# sourceMappingURL=enumerator.js.map