import { disposableMixin, createDisposable } from "@reactive-js/disposable";
export class AbstractEnumerator {
    constructor() {
        this.add = disposableMixin.add;
        this.disposable = createDisposable();
        this.dispose = disposableMixin.dispose;
    }
    get isDisposed() {
        return this.disposable.isDisposed;
    }
}
export class AbstractDelegatingEnumerator extends AbstractEnumerator {
    constructor(delegate) {
        super();
        this.delegate = delegate;
        delegate.add(this);
    }
}
//# sourceMappingURL=enumerator.js.map